设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 105|回复: 0

[每日一码] LWPOLYLINE UNION

[复制链接]

已领礼包: 40个

财富等级: 招财进宝

发表于 2021-1-17 03:51:11 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
本帖最后由 newer 于 2021-1-17 03:52 编辑

UPL2.gif
  1. using System;
  2. using System.Collections.Generic;
  3. using System.Globalization;
  4. using Autodesk.AutoCAD.ApplicationServices;
  5. using Autodesk.AutoCAD.DatabaseServices;
  6. using Autodesk.AutoCAD.EditorInput;
  7. using Autodesk.AutoCAD.Geometry;
  8. using Autodesk.AutoCAD.Runtime;
  9. using AcAp = Autodesk.AutoCAD.ApplicationServices.Application;

  10. namespace MergePlines
  11. {
  12.     public class Commands
  13.     {
  14.         bool _en;
  15.         Document _doc;

  16.         public Commands()
  17.         {
  18.             //System.Threading.Thread.CurrentThread.CurrentCulture = new CultureInfo("en-US");
  19.             //System.Threading.Thread.CurrentThread.CurrentUICulture = new CultureInfo("en-US");
  20.             _en = CultureInfo.CurrentCulture.Name.StartsWith("en-");
  21.             _doc = AcAp.DocumentManager.MdiActiveDocument;
  22.         }

  23.         class Segment
  24.         {
  25.             public Point2d StartPt { get; set; }
  26.             public Point2d EndPt { get; set; }
  27.             public double Bulge { get; set; }
  28.         }

  29.         private int MergePlines(ObjectIdCollection ids, bool erase)
  30.         {
  31.             Database db = _doc.Database;
  32.             int result = 0;
  33.             using (Transaction tr = db.TransactionManager.StartTransaction())
  34.             using (DBObjectCollection segments = new DBObjectCollection())
  35.             {
  36.                 BlockTableRecord btr =
  37.                     (BlockTableRecord)tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite);
  38.                 List<Segment> segs = new List<Segment>();
  39.                 List<Polyline> plines = new List<Polyline>();
  40.                 Polyline pl;
  41.                 while (ids.Count > 0)
  42.                 {
  43.                     pl = (Polyline)tr.GetObject(ids[0], OpenMode.ForWrite);
  44.                     Vector3d normal = pl.Normal;
  45.                     double elev = pl.Elevation;
  46.                     Plane plane = new Plane(Point3d.Origin, normal);
  47.                     plines.Add(pl);
  48.                     ids.RemoveAt(0);
  49.                     for (int i = 0; i < ids.Count; )
  50.                     {
  51.                         pl = (Polyline)tr.GetObject(ids, OpenMode.ForWrite);
  52.                         if (Math.Abs(pl.Elevation - elev) < 1e-12 && pl.Normal.IsEqualTo(normal))
  53.                         {
  54.                             plines.Add(pl);
  55.                             ids.RemoveAt(i);
  56.                         }
  57.                         else
  58.                             i++;
  59.                     }
  60.                     if (plines.Count < 2)
  61.                         continue;
  62.                     for (int i = 0; i < plines.Count; i++)
  63.                     {
  64.                         pl = plines;
  65.                         pl.Explode(segments);
  66.                         if (erase) pl.Erase();
  67.                     }
  68.                     plines.Clear();
  69.                     using (DBObjectCollection regions = Region.CreateFromCurves(segments))
  70.                     {
  71.                         Region reg = (Region)regions[0];
  72.                         for (int i = 1; i < regions.Count; i++)
  73.                         {
  74.                             reg.BooleanOperation(BooleanOperationType.BoolUnite, (Region)regions);
  75.                             regions.Dispose();
  76.                         }
  77.                         foreach (DBObject o in segments) o.Dispose();
  78.                         segments.Clear();
  79.                         reg.Explode(segments);
  80.                         reg.Dispose();
  81.                         for (int i = 0; i < segments.Count; i++)
  82.                         {
  83.                             if (segments is Region)
  84.                             {
  85.                                 ((Region)segments).Explode(segments);
  86.                                 continue;
  87.                             }
  88.                             Curve crv = (Curve)segments;
  89.                             Point3d start = crv.StartPoint;
  90.                             Point3d end = crv.EndPoint;
  91.                             double bulge = 0.0;
  92.                             if (crv is Arc)
  93.                             {
  94.                                 Arc arc = (Arc)crv;
  95.                                 double angle = arc.Center.GetVectorTo(start).GetAngleTo(arc.Center.GetVectorTo(end), arc.Normal);
  96.                                 bulge = Math.Tan(angle / 4.0);
  97.                             }
  98.                             segs.Add(new Segment { StartPt = start.Convert2d(plane), EndPt = end.Convert2d(plane), Bulge = bulge });
  99.                         }
  100.                         foreach (DBObject o in segments) o.Dispose();
  101.                         segments.Clear();
  102.                         while (segs.Count > 0)
  103.                         {
  104.                             using (Polyline pline = new Polyline())
  105.                             {
  106.                                 pline.AddVertexAt(0, segs[0].StartPt, segs[0].Bulge, 0.0, 0.0);
  107.                                 Point2d pt = segs[0].EndPt;
  108.                                 segs.RemoveAt(0);
  109.                                 int vtx = 1;
  110.                                 while (true)
  111.                                 {
  112.                                     int i = segs.FindIndex(delegate(Segment s)
  113.                                     {
  114.                                         return s.StartPt.IsEqualTo(pt) || s.EndPt.IsEqualTo(pt);
  115.                                     });
  116.                                     if (i < 0) break;
  117.                                     Segment seg = segs;
  118.                                     if (seg.EndPt.IsEqualTo(pt))
  119.                                         seg = new Segment { StartPt = seg.EndPt, EndPt = seg.StartPt, Bulge = -seg.Bulge };
  120.                                     pline.AddVertexAt(vtx, seg.StartPt, seg.Bulge, 0.0, 0.0);
  121.                                     pt = seg.EndPt;
  122.                                     segs.RemoveAt(i);
  123.                                     vtx++;
  124.                                 }
  125.                                 pline.SetDatabaseDefaults();
  126.                                 pline.Closed = true;
  127.                                 pline.Normal = normal;
  128.                                 pline.Elevation = elev;
  129.                                 btr.AppendEntity(pline);
  130.                                 tr.AddNewlyCreatedDBObject(pline, true);
  131.                                 result++;
  132.                             }
  133.                         }
  134.                         segs.Clear();
  135.                     }
  136.                 }
  137.                 tr.Commit();
  138.             }
  139.             return result;
  140.         }

  141.         [CommandMethod("UPL", CommandFlags.UsePickSet)]
  142.         public void UnionPlines()
  143.         {
  144.             Editor ed = _doc.Editor;
  145.             TypedValue[] filter = new TypedValue[3]{
  146.                 new TypedValue(0, "LWPOLYLINE"),
  147.                 new TypedValue(-4, "&"),
  148.                 new TypedValue(70, 1)};
  149.             PromptSelectionResult psr = ed.GetSelection(new SelectionFilter(filter));
  150.             if (psr.Status != PromptStatus.OK)
  151.                 return;
  152.             PromptKeywordOptions pko = new PromptKeywordOptions("\nEffacer les polylignes source ?: ");
  153.             if (_en)
  154.             {
  155.                 pko.Message = "\nErase source polylines ?: ";
  156.                 pko.Keywords.Add("Yes");
  157.                 pko.Keywords.Add("No");
  158.                 pko.Keywords.Default = "Yes";
  159.             }
  160.             else
  161.             {
  162.                 pko.Keywords.Add("Oui");
  163.                 pko.Keywords.Add("Non");
  164.                 pko.Keywords.Default = "Oui";
  165.             }
  166.             pko.AllowNone = true;
  167.             PromptResult pr = ed.GetKeywords(pko);
  168.             if (pr.Status == PromptStatus.Cancel)
  169.                 return;
  170.             bool erase = _en ? pr.StringResult == "Yes" : pr.StringResult == "Oui";
  171.             try
  172.             {
  173.                 ObjectIdCollection ids = new ObjectIdCollection(psr.Value.GetObjectIds());
  174.                 int n = MergePlines(ids, erase);
  175.                 if (_en)
  176.                     ed.WriteMessage("\n{0} polyline{1} have been created", n, n > 1 ? "s" : "");
  177.                 else
  178.                     ed.WriteMessage("\n{0} polyligne{1} créée{1}", n, n > 1 ? "s" : "");
  179.             }
  180.             catch (Autodesk.AutoCAD.Runtime.Exception e)
  181.             {
  182.                 ed.WriteMessage("\n{0}: {1}\n{2}", _en ? "Error" : "Erreur", e.Message, e.StackTrace);
  183.             }
  184.         }
  185.     }
  186. }

请点击此处下载

查看状态:需购买或无权限

您的用户组是:游客

文件名称:MergePlines.zip 
下载次数:4  文件大小:4.47 KB 
下载权限: 实习生 以上  [免费赚D豆]


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2021-2-28 06:35 , Processed in 0.111443 second(s), 16 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表